# Editors ## ListEditors `client.editors.list(EditorListParamsparams, RequestOptionsoptions?): EditorsPage` **post** `/gitpod.v1.EditorService/ListEditors` Lists all available code editors, optionally filtered to those allowed in an organization. Use this method to: - View supported editors - Get editor capabilities - Browse editor options - Check editor availability ### Examples - List editors: Shows all available editors with pagination. ```yaml pagination: pageSize: 20 ``` - List editors available to the organization: Shows all available editors that are allowed by the policies enforced in the organization with pagination. ```yaml pagination: pageSize: 20 filter: allowedByPolicy: true ``` ### Parameters - `params: EditorListParams` - `token?: string` Query param - `pageSize?: number` Query param - `filter?: Filter` Body param: filter contains the filter options for listing editors - `allowedByPolicy?: boolean` allowed_by_policy filters the response to only editors that are allowed by the policies enforced in the organization - `pagination?: Pagination` Body param: pagination contains the pagination options for listing environments - `token?: string` Token for the next set of results that was returned as next_token of a PaginationResponse - `pageSize?: number` Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. ### Returns - `Editor` - `id: string` - `installationInstructions: string` - `name: string` - `urlTemplate: string` - `alias?: string` - `iconUrl?: string` - `shortDescription?: string` - `versions?: Array` versions contains the list of available versions for this editor - `version: string` version is the version string of the editor Examples for JetBrains: 2025.2 ### Example ```typescript import Gitpod from '@gitpod/sdk'; const client = new Gitpod({ bearerToken: process.env['GITPOD_API_KEY'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const editor of client.editors.list({ pagination: { pageSize: 20 } })) { console.log(editor.id); } ``` #### Response ```json { "editors": [ { "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", "installationInstructions": "installationInstructions", "name": "name", "urlTemplate": "urlTemplate", "alias": "alias", "iconUrl": "iconUrl", "shortDescription": "shortDescription", "versions": [ { "version": "version" } ] } ], "pagination": { "nextToken": "nextToken" } } ``` ## ResolveEditorURL `client.editors.resolveURL(EditorResolveURLParamsbody, RequestOptionsoptions?): EditorResolveURLResponse` **post** `/gitpod.v1.EditorService/ResolveEditorURL` Resolves the URL for accessing an editor in a specific environment. Use this method to: - Get editor access URLs - Launch editors for environments - Set up editor connections - Configure editor access ### Examples - Resolve editor URL: Gets the URL for accessing an editor in an environment. ```yaml editorId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" environmentId: "07e03a28-65a5-4d98-b532-8ea67b188048" organizationId: "b0e12f6c-4c67-429d-a4a6-d9838b5da047" ``` ### Parameters - `body: EditorResolveURLParams` - `editorId: string` editorId is the ID of the editor to resolve the URL for - `environmentId: string` environmentId is the ID of the environment to resolve the URL for - `organizationId: string` organizationId is the ID of the organization to resolve the URL for - `version?: string` version is the editor version to use If not provided, the latest version will be installed Examples for JetBrains: 2025.2 ### Returns - `EditorResolveURLResponse` - `url: string` url is the resolved editor URL ### Example ```typescript import Gitpod from '@gitpod/sdk'; const client = new Gitpod({ bearerToken: process.env['GITPOD_API_KEY'], // This is the default and can be omitted }); const response = await client.editors.resolveURL({ editorId: 'd2c94c27-3b76-4a42-b88c-95a85e392c68', environmentId: '07e03a28-65a5-4d98-b532-8ea67b188048', organizationId: 'b0e12f6c-4c67-429d-a4a6-d9838b5da047', }); console.log(response.url); ``` #### Response ```json { "url": "url" } ``` ## GetEditor `client.editors.retrieve(EditorRetrieveParamsbody, RequestOptionsoptions?): EditorRetrieveResponse` **post** `/gitpod.v1.EditorService/GetEditor` Gets details about a specific editor. Use this method to: - View editor information - Get editor configuration ### Examples - Get editor details: Retrieves information about a specific editor. ```yaml id: "d2c94c27-3b76-4a42-b88c-95a85e392c68" ``` ### Parameters - `body: EditorRetrieveParams` - `id: string` id is the ID of the editor to get ### Returns - `EditorRetrieveResponse` - `editor: Editor` editor contains the editor - `id: string` - `installationInstructions: string` - `name: string` - `urlTemplate: string` - `alias?: string` - `iconUrl?: string` - `shortDescription?: string` - `versions?: Array` versions contains the list of available versions for this editor - `version: string` version is the version string of the editor Examples for JetBrains: 2025.2 ### Example ```typescript import Gitpod from '@gitpod/sdk'; const client = new Gitpod({ bearerToken: process.env['GITPOD_API_KEY'], // This is the default and can be omitted }); const editor = await client.editors.retrieve({ id: 'd2c94c27-3b76-4a42-b88c-95a85e392c68' }); console.log(editor.editor); ``` #### Response ```json { "editor": { "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", "installationInstructions": "installationInstructions", "name": "name", "urlTemplate": "urlTemplate", "alias": "alias", "iconUrl": "iconUrl", "shortDescription": "shortDescription", "versions": [ { "version": "version" } ] } } ``` ## Domain Types ### Editor - `Editor` - `id: string` - `installationInstructions: string` - `name: string` - `urlTemplate: string` - `alias?: string` - `iconUrl?: string` - `shortDescription?: string` - `versions?: Array` versions contains the list of available versions for this editor - `version: string` version is the version string of the editor Examples for JetBrains: 2025.2 ### Editor Version - `EditorVersion` - `version: string` version is the version string of the editor Examples for JetBrains: 2025.2 ### Editor Resolve URL Response - `EditorResolveURLResponse` - `url: string` url is the resolved editor URL ### Editor Retrieve Response - `EditorRetrieveResponse` - `editor: Editor` editor contains the editor - `id: string` - `installationInstructions: string` - `name: string` - `urlTemplate: string` - `alias?: string` - `iconUrl?: string` - `shortDescription?: string` - `versions?: Array` versions contains the list of available versions for this editor - `version: string` version is the version string of the editor Examples for JetBrains: 2025.2